WinStd Additional templates and function helpers for Microsoft Windows using Standard C++ classes

Public Member Functions | List of all members
winstd::file Class Reference
Windows API

File handle wrapper. More...

`#include <Win.h>`

Inheritance diagram for winstd::file:

## Public Member Functions
bool | create (_In_z_ LPCTSTR lpFileName, _In_ DWORD dwDesiredAccess, _In_ DWORD dwShareMode, _In_ DWORD dwCreationDisposition, _In_opt_ DWORD dwFlagsAndAttributes=FILE_ATTRIBUTE_NORMAL, _In_opt_ LPSECURITY_ATTRIBUTES lpSecurityAttributes=NULL, _In_opt_ HANDLE hTemplateFile=NULL) noexcept
| Opens file handle. More...
Public Member Functions inherited from winstd::win_handle< INVALID_HANDLE_VALUE >
virtual | ~win_handle ()
| Closes an open object handle. More...
Public Member Functions inherited from winstd::handle< HANDLE, INVALID >
| handle () noexcept
| Initializes a new class instance with the object handle set to INVAL.
| handle (_In_opt_ handle_type h) noexcept
| Initializes a new class instance with an already available object handle. More...
| handle (_Inout_ handle< handle_type, INVAL > &&h) noexcept
| Move constructor. More...
handle< handle_type, INVAL > & | operator= (_In_opt_ handle_type h) noexcept
| Attaches already available object handle. More...
handle< handle_type, INVAL > & | operator= (_Inout_ handle< handle_type, INVAL > &&h) noexcept
| Move assignment. More...
| operator handle_type () const
| Auto-typecasting operator. More...
handle_type *& | operator* () const
| Returns the object handle value when the object handle is a pointer to a value (class, struct, etc.). More...
handle_type * | operator& ()
| Returns the object handle reference. More...
handle_type | operator-> () const
| Provides object handle member access when the object handle is a pointer to a class or struct. More...
bool | operator! () const
| Tests if the object handle is INVAL. More...
bool | operator< (_In_opt_ handle_type h) const
| Is handle less than? More...
bool | operator<= (_In_opt_ handle_type h) const
| Is handle less than or equal to? More...
bool | operator>= (_In_opt_ handle_type h) const
| Is handle greater than or equal to? More...
bool | operator> (_In_opt_ handle_type h) const
| Is handle greater than? More...
bool | operator!= (_In_opt_ handle_type h) const
| Is handle not equal to? More...
bool | operator== (_In_opt_ handle_type h) const
| Is handle equal to? More...
void | attach (_In_opt_ handle_type h) noexcept
| Sets a new object handle for the class. More...
handle_type | detach ()
| Dismisses the object handle from this class. More...
void | free ()
| Destroys the object.

## Additional Inherited Members
Public Types inherited from winstd::handle< HANDLE, INVALID >
typedef HANDLE | handle_type
| Datatype of the object handle this template class handles.
Static Public Attributes inherited from winstd::handle< HANDLE, INVALID >
static const HANDLE | invalid
| Invalid handle value.
Protected Member Functions inherited from winstd::win_handle< INVALID_HANDLE_VALUE >
void | free_internal () noexcept override
| Closes an open object handle. More...
virtual void | free_internal () noexcept=0
| Abstract member function that must be implemented by child classes to do the actual object destruction. More...
Protected Attributes inherited from winstd::handle< HANDLE, INVALID >
handle_type | m_h
| Object handle.

## Detailed Description

File handle wrapper.

## Member Function Documentation

## ◆ create()

bool winstd::file::create | ( | _In_z_ LPCTSTR | lpFileName,
|  | _In_ DWORD | dwDesiredAccess,
|  | _In_ DWORD | dwShareMode,
|  | _In_ DWORD | dwCreationDisposition,
|  | _In_opt_ DWORD | dwFlagsAndAttributes = `FILE_ATTRIBUTE_NORMAL`,
|  | _In_opt_ LPSECURITY_ATTRIBUTES | lpSecurityAttributes = `NULL`,
|  | _In_opt_ HANDLE | hTemplateFile = `NULL`
| ) |  |
| inline noexcept

Opens file handle.

See also
  CreateFile function

Returns
  - `true` when succeeds;
  - `false` when fails. Use `GetLastError()` for failure reason.

The documentation for this class was generated from the following file:

- include/WinStd/Win.h